diff -rupN arpack++1.2.orig/include/argsym.h arpack++1.2.patched/include/argsym.h
--- arpack++1.2.orig/include/argsym.h	2000-02-21 19:22:35.000000000 +0100
+++ arpack++1.2.patched/include/argsym.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARGSYM_H
 #define ARGSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arssym.h"
 #include "arrgsym.h"
@@ -79,7 +80,7 @@ class ARSymGenEig:
 
  // d.3) Constructors and destructor.
 
-  ARSymGenEig() { InvertMode = 'S'; }
+  ARSymGenEig() { this->InvertMode = 'S'; }
   // Short constructor that does almost nothing.
 
   ARSymGenEig(int np, int nevp, ARFOP* objOPp,
@@ -132,7 +133,7 @@ Copy(const ARSymGenEig<ARFLOAT, ARFOP, A
   ARGenEig<ARFLOAT, ARFLOAT, ARFOP, ARFB>::Copy(other);
   objA       = other.objA;
   MultAx     = other.MultAx;
-  InvertMode = other.InvertMode;
+  this->InvertMode = other.InvertMode;
 
 } // Copy.
 
@@ -143,9 +144,9 @@ SetShiftInvertMode(ARFLOAT sigmap, ARFOP
                    void (ARFOP::* MultOPxp)(ARFLOAT[], ARFLOAT[]))
 {
 
-  InvertMode = 'S';
-  objOP      = objOPp;
-  MultOPx    = MultOPxp;
+  this->InvertMode = 'S';
+  this->objOP      = objOPp;
+  this->MultOPx    = MultOPxp;
   ChangeShift(sigmap);
 
 } // SetShiftInvertMode.
@@ -158,9 +159,9 @@ SetBucklingMode(ARFLOAT sigmap, ARFOP* o
 
 {
 
-  InvertMode = 'B';
-  objOP      = objOPp;
-  MultOPx    = MultOPxp;
+  this->InvertMode = 'B';
+  this->objOP      = objOPp;
+  this->MultOPx    = MultOPxp;
   ChangeShift(sigmap);
 
 } // SetBucklingMode.
@@ -174,9 +175,9 @@ SetCayleyMode(ARFLOAT sigmap, ARFOP* obj
 
 {
 
-  InvertMode = 'C';
-  objOP      = objOPp;
-  MultOPx    = MultOPxp;
+  this->InvertMode = 'C';
+  this->objOP      = objOPp;
+  this->MultOPx    = MultOPxp;
   objA       = objAp;
   MultAx     = MultAxp;
   ChangeShift(sigmap);
@@ -190,64 +191,64 @@ int ARSymGenEig<ARFLOAT, ARFOP, ARFB>::F
 
   ARFLOAT* temp;
 
-  if (mode != 5) {  // Using base function if not in Cayley mode.
+  if (this->mode != 5) {  // Using base function if not in Cayley mode.
     return ARGenEig<ARFLOAT, ARFLOAT, ARFOP, ARFB>::FindArnoldiBasis();
   }
   else {
 
-    temp = new ARFLOAT[n+1];
+    temp = new ARFLOAT[this->n+1];
 
-    if (!BasisOK) Restart();
+    if (!this->BasisOK) this->Restart();
 
     // Changing to auto shift mode.
 
-    if (!AutoShift) {
+    if (!this->AutoShift) {
       ArpackError::Set(ArpackError::CHANGING_AUTOSHIFT, "FindArnoldiBasis");
-      AutoShift=true;
+      this->AutoShift=true;
     }
 
     // ARPACK main loop.
 
-    while (!BasisOK) {
+    while (!this->BasisOK) {
 
       // Calling Aupp.
 
-      try { TakeStep(); }
+      try { this->TakeStep(); }
       catch (ArpackError) {
         ArpackError(ArpackError::CANNOT_FIND_BASIS, "FindArnoldiBasis");
         delete[] temp;
         return 0;
       }
 
-      switch (ido) {
+      switch (this->ido) {
       case -1:
 
         // Performing y <- B*x for the first time.
 
-        ipntr[3] = ipntr[2]+n; // not a clever idea, but...
-        (objB->*MultBx)(&workd[ipntr[1]],&workd[ipntr[3]]);
+        this->ipntr[3] = this->ipntr[2]+this->n; // not a clever idea, but...
+        (this->objB->*(this->MultBx))(&this->workd[this->ipntr[1]],&this->workd[this->ipntr[3]]);
 
       case  1:
 
         // Performing y <- OP*(A+sigma*B)*x, B*x is already available.
 
-        (objB->*MultAx)(&workd[ipntr[1]], temp);
-        axpy(n, sigmaR, &workd[ipntr[3]], 1, temp, 1);
-        (objOP->*MultOPx)(temp, &workd[ipntr[2]]);
+        (this->objB->*MultAx)(&this->workd[this->ipntr[1]], temp);
+        axpy(this->n, this->sigmaR, &this->workd[this->ipntr[3]], 1, temp, 1);
+        (this->objOP->*(this->MultOPx))(temp, &this->workd[this->ipntr[2]]);
         break;
 
       case  2:
 
         // Performing y <- B*x.
 
-        (objB->*MultBx)(&workd[ipntr[1]],&workd[ipntr[2]]);
+        (this->objB->*(this->MultBx))(&this->workd[this->ipntr[1]],&this->workd[this->ipntr[2]]);
 
       }
     }
 
     delete[] temp;
    
-    return nconv;
+    return this->nconv;
   }
 
 } // FindArnoldiBasis.
@@ -263,8 +264,8 @@ ARSymGenEig(int np, int nevp, ARFOP* obj
 
 {
 
-  InvertMode = 'S';   
-  NoShift();
+  this->InvertMode = 'S';   
+  this->NoShift();
   DefineParameters(np, nevp, objOPp, MultOPxp, objBp, MultBxp,
                    whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
@@ -281,7 +282,7 @@ ARSymGenEig(char InvertModep, int np, in
 
 {
 
-  InvertMode = CheckInvertMode(InvertModep); // InvertMode = 'S' or 'B'.
+  this->InvertMode = this->CheckInvertMode(InvertModep); // InvertMode = 'S' or 'B'.
   ChangeShift(sigmap);
   DefineParameters(np, nevp, objOPp, MultOPxp, objBp, MultBxp,
                    whichp, ncvp, tolp, maxitp, residp, ishiftp);
@@ -300,7 +301,7 @@ ARSymGenEig(int np, int nevp, ARFOP* obj
 
 {
 
-  SetCayleyMode(sigmap, objOPp, MultOPx, objAp, MultAxp);
+  SetCayleyMode(sigmap, objOPp, this->MultOPx, objAp, MultAxp);
   DefineParameters(np, nevp, objOPp, MultOPxp, objBp, MultBxp,
                    whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
@@ -313,7 +314,7 @@ operator=(const ARSymGenEig<ARFLOAT, ARF
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arhbmat.h arpack++1.2.patched/include/arhbmat.h
--- arpack++1.2.orig/include/arhbmat.h	2000-02-21 19:37:14.000000000 +0100
+++ arpack++1.2.patched/include/arhbmat.h	2006-01-26 15:37:50.000000000 +0100
@@ -20,10 +20,11 @@
 #ifndef ARHBMAT_H
 #define ARHBMAT_H
 
-#include <stddef.h>
-#include <fstream.h>
-#include <stdlib.h>
-#include <string.h>
+#include <cstddef>
+#include <fstream>
+#include <cstdlib>
+#include <cstring>
+
 #include "arch.h"
 #include "arerror.h"
 
@@ -46,17 +47,17 @@ class ARhbMatrix {
 
   void ConvertDouble(char* num);
 
-  bool ReadEntry(ifstream& file, int nval, int fval, int& j, double& val);
+  bool ReadEntry(std::ifstream& file, int nval, int fval, int& j, double& val);
 
-  bool ReadEntry(ifstream& file, int nval, int fval, int& j, float& val);
+  bool ReadEntry(std::ifstream& file, int nval, int fval, int& j, float& val);
 
-  bool ReadEntry(ifstream& file, int nval, int fval,
+  bool ReadEntry(std::ifstream& file, int nval, int fval,
                  int& j, arcomplex<double>& val);
 
-  bool ReadEntry(ifstream& file, int nval, int fval,
+  bool ReadEntry(std::ifstream& file, int nval, int fval,
                  int& j, arcomplex<float>& val);
 
-  void ReadFormat(ifstream& file, int& n, int& fmt);
+  void ReadFormat(std::ifstream& file, int& n, int& fmt);
 
  public:
 
@@ -131,7 +132,7 @@ inline void ARhbMatrix<ARINT, ARTYPE>::C
 
 template<class ARINT, class ARTYPE>
 inline bool ARhbMatrix<ARINT, ARTYPE>::
-ReadEntry(ifstream& file, int nval, int fval, int& j, double& val)
+ReadEntry(std::ifstream& file, int nval, int fval, int& j, double& val)
 {
 
   char num[81];
@@ -152,7 +153,7 @@ ReadEntry(ifstream& file, int nval, int 
 
 template<class ARINT, class ARTYPE>
 inline bool ARhbMatrix<ARINT, ARTYPE>::
-ReadEntry(ifstream& file, int nval, int fval, int& j, float& val)
+ReadEntry(std::ifstream& file, int nval, int fval, int& j, float& val)
 {
 
   double dval;
@@ -167,7 +168,7 @@ ReadEntry(ifstream& file, int nval, int 
 
 template<class ARINT, class ARTYPE>
 inline bool ARhbMatrix<ARINT, ARTYPE>::
-ReadEntry(ifstream& file, int nval, int fval,
+ReadEntry(std::ifstream& file, int nval, int fval,
           int& j, arcomplex<double>& val)
 {
 
@@ -196,7 +197,7 @@ ReadEntry(ifstream& file, int nval, int 
 
 template<class ARINT, class ARTYPE>
 inline bool ARhbMatrix<ARINT, ARTYPE>::
-ReadEntry(ifstream& file, int nval, int fval,
+ReadEntry(std::ifstream& file, int nval, int fval,
           int& j, arcomplex<float>& val)
 {
 
@@ -227,7 +228,7 @@ ReadEntry(ifstream& file, int nval, int 
 
 
 template<class ARINT, class ARTYPE>
-void ARhbMatrix<ARINT, ARTYPE>::ReadFormat(ifstream& file, int& n, int& fmt)
+void ARhbMatrix<ARINT, ARTYPE>::ReadFormat(std::ifstream& file, int& n, int& fmt)
 {
 
   char c;
@@ -267,7 +268,7 @@ void ARhbMatrix<ARINT, ARTYPE>::Define(c
   // Opening file.
 
   datafile = filename;
-  ifstream file(datafile);
+  std::ifstream file(datafile);
   
   if (!file) {
     throw ArpackError(ArpackError::CANNOT_OPEN_FILE, "ARhbMatrix");
diff -rupN arpack++1.2.orig/include/arlgcomp.h arpack++1.2.patched/include/arlgcomp.h
--- arpack++1.2.orig/include/arlgcomp.h	2000-02-21 01:31:04.000000000 +0100
+++ arpack++1.2.patched/include/arlgcomp.h	2006-01-26 15:37:50.000000000 +0100
@@ -18,7 +18,8 @@
 #ifndef ARLGCOMP_H
 #define ARLGCOMP_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arlnsmat.h"
 #include "arlnspen.h"
@@ -103,9 +104,9 @@ Copy(const ARluCompGenEig<ARFLOAT>& othe
   ARCompGenEig<ARFLOAT, ARluNonSymPencil<arcomplex<ARFLOAT>, ARFLOAT >,
                ARluNonSymPencil<arcomplex<ARFLOAT>, ARFLOAT> >:: Copy(other);
   Pencil = other.Pencil;
-  objOP  = &Pencil;
-  objB   = &Pencil;
-  if (mode > 2) objOP->FactorAsB(sigmaR);
+  this->objOP  = &Pencil;
+  this->objB   = &Pencil;
+  if (this->mode > 2) this->objOP->FactorAsB(this->sigmaR);
 
 } // Copy.
 
@@ -114,7 +115,7 @@ template<class ARFLOAT>
 inline void ARluCompGenEig<ARFLOAT>::ChangeShift(arcomplex<ARFLOAT> sigmap)
 {
 
-  objOP->FactorAsB(sigmap);
+  this->objOP->FactorAsB(sigmap);
   ARrcStdEig<ARFLOAT, arcomplex<ARFLOAT> >::ChangeShift(sigmap);
 
 } // ChangeShift.
@@ -155,7 +156,7 @@ ARluCompGenEig(int nevp, ARluNonSymMatri
 {
 
   Pencil.DefineMatrices(A, B);
-  NoShift();
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &Pencil,
                    &ARluNonSymPencil<arcomplex<ARFLOAT>, ARFLOAT>::MultInvBAv,
                    &Pencil, 
@@ -192,7 +193,7 @@ operator=(const ARluCompGenEig<ARFLOAT>&
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arlgnsym.h arpack++1.2.patched/include/arlgnsym.h
--- arpack++1.2.orig/include/arlgnsym.h	2000-02-21 01:25:52.000000000 +0100
+++ arpack++1.2.patched/include/arlgnsym.h	2006-01-26 15:37:50.000000000 +0100
@@ -18,7 +18,8 @@
 #ifndef ARLGNSYM_H
 #define ARLGNSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arlnsmat.h"
 #include "arlnspen.h"
@@ -110,15 +111,15 @@ Copy(const ARluNonSymGenEig<ARFLOAT>& ot
   ARNonSymGenEig<ARFLOAT, ARluNonSymPencil<ARFLOAT, ARFLOAT>,
                  ARluNonSymPencil<ARFLOAT, ARFLOAT> >:: Copy(other);
   Pencil = other.Pencil;
-  objOP  = &Pencil;
-  objB   = &Pencil;
-  objA   = &Pencil;
-  if (mode > 2) {
-    if (sigmaI == 0.0) {
-      objOP->FactorAsB(sigmaR);
+  this->objOP  = &Pencil;
+  this->objB   = &Pencil;
+  this->objA   = &Pencil;
+  if (this->mode > 2) {
+    if (this->sigmaI == 0.0) {
+      this->objOP->FactorAsB(this->sigmaR);
     }
     else {
-      objOP->FactorAsB(sigmaR, sigmaI, part);
+      this->objOP->FactorAsB(this->sigmaR, this->sigmaI, this->part);
     }
   }
 
@@ -131,10 +132,10 @@ ChangeShift(ARFLOAT sigmaRp, ARFLOAT sig
 {
 
   if (sigmaIp == 0.0) {
-    objOP->FactorAsB(sigmaRp);
+    this->objOP->FactorAsB(sigmaRp);
   }
   else {
-    objOP->FactorAsB(sigmaRp, sigmaIp, part);
+    this->objOP->FactorAsB(sigmaRp, sigmaIp, this->part);
   }
   ARrcNonSymGenEig<ARFLOAT>::ChangeShift(sigmaRp, sigmaIp);
 
@@ -186,7 +187,7 @@ ARluNonSymGenEig(int nevp, ARluNonSymMat
 {
 
   Pencil.DefineMatrices(A, B);
-  NoShift();
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &Pencil,
                    &ARluNonSymPencil<ARFLOAT, ARFLOAT>::MultInvBAv, &Pencil,
                    &ARluNonSymPencil<ARFLOAT, ARFLOAT>::MultBv, whichp,
@@ -240,7 +241,7 @@ operator=(const ARluNonSymGenEig<ARFLOAT
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arlgsym.h arpack++1.2.patched/include/arlgsym.h
--- arpack++1.2.orig/include/arlgsym.h	2000-02-21 01:20:30.000000000 +0100
+++ arpack++1.2.patched/include/arlgsym.h	2006-01-26 15:37:50.000000000 +0100
@@ -19,7 +19,8 @@
 #ifndef ARLGSYM_H
 #define ARLGSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arlsmat.h"
 #include "arlspen.h"
@@ -105,10 +106,10 @@ Copy(const ARluSymGenEig<ARFLOAT>& other
   ARSymGenEig<ARFLOAT, ARluSymPencil<ARFLOAT>,
               ARluSymPencil<ARFLOAT> >:: Copy(other);
   Pencil = other.Pencil;
-  objOP  = &Pencil;
-  objB   = &Pencil;
-  objA   = &Pencil;
-  if (mode > 2) objOP->FactorAsB(sigmaR);
+  this->objOP  = &Pencil;
+  this->objB   = &Pencil;
+  this->objA   = &Pencil;
+  if (this->mode > 2) this->objOP->FactorAsB(this->sigmaR);
 
 } // Copy.
 
@@ -117,7 +118,7 @@ template<class ARFLOAT>
 inline void ARluSymGenEig<ARFLOAT>::ChangeShift(ARFLOAT sigmap)
 {
 
-  objOP->FactorAsB(sigmap);
+  this->objOP->FactorAsB(sigmap);
   ARrcSymGenEig<ARFLOAT>::ChangeShift(sigmap);
 
 } // ChangeShift.
@@ -179,8 +180,8 @@ ARluSymGenEig(int nevp, ARluSymMatrix<AR
 {
 
   Pencil.DefineMatrices(A, B);
-  InvertMode = 'S';
-  NoShift();
+  this->InvertMode = 'S';
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &Pencil,
                    &ARluSymPencil<ARFLOAT>::MultInvBAv, &Pencil,
                    &ARluSymPencil<ARFLOAT>::MultBv, whichp,
@@ -203,8 +204,8 @@ ARluSymGenEig(char InvertModep, int nevp
                    &ARluSymPencil<ARFLOAT>::MultInvAsBv, &Pencil,
                    &ARluSymPencil<ARFLOAT>::MultBv, whichp,
                    ncvp, tolp, maxitp, residp, ishiftp);
-  InvertMode = CheckInvertMode(InvertModep);
-  switch (InvertMode) {
+  this->InvertMode = this->CheckInvertMode(InvertModep);
+  switch (this->InvertMode) {
   case 'B':  // Buckling mode.
     ChangeMultBx(&Pencil, &ARluSymPencil<ARFLOAT>::MultAv);
   case 'S':  // Shift and invert mode.
@@ -223,7 +224,7 @@ operator=(const ARluSymGenEig<ARFLOAT>& 
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arlnsmat.h arpack++1.2.patched/include/arlnsmat.h
--- arpack++1.2.orig/include/arlnsmat.h	2000-02-22 14:27:32.000000000 +0100
+++ arpack++1.2.patched/include/arlnsmat.h	2006-01-26 15:37:50.000000000 +0100
@@ -20,7 +20,8 @@
 #ifndef ARLNSMAT_H
 #define ARLNSMAT_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "armat.h"
 #include "arhbmat.h"
@@ -130,16 +131,16 @@ bool ARluNonSymMatrix<ARTYPE, ARFLOAT>::
   // Checking if pcol is in ascending order.
 
   i = 0;
-  while ((i!=n)&&(pcol[i]<=pcol[i+1])) i++;
-  if (i!=n) return false;
+  while ((i!=this->n)&&(pcol[i]<=pcol[i+1])) i++;
+  if (i!=this->n) return false;
 
   // Checking if irow components are in order and within bounds.
 
-  for (i=0; i!=n; i++) {
+  for (i=0; i!=this->n; i++) {
     j = pcol[i];
     k = pcol[i+1]-1;
     if (j<=k) {
-      if ((irow[j]<0)||(irow[k]>=n)) return false;
+      if ((irow[j]<0)||(irow[k]>=this->n)) return false;
       while ((j!=k)&&(irow[j]<irow[j+1])) j++;
       if (j!=k) return false;
     }
@@ -157,12 +158,12 @@ Copy(const ARluNonSymMatrix<ARTYPE, ARFL
 
   // Copying very fundamental variables.
 
-  defined   = other.defined;
+  this->defined   = other.defined;
   factored  = other.factored;
 
   // Returning from here if "other" was not initialized.
 
-  if (!defined) return;
+  if (!this->defined) return;
 
   // Copying user-defined parameters.
 
@@ -198,7 +199,7 @@ void ARluNonSymMatrix<ARTYPE, ARFLOAT>::
     Destroy_CompCol_Matrix(&U);
     StatFree();
   }
-  if (defined) {
+  if (this->defined) {
     Destroy_SuperMatrix_Store(&A); // delete A.Store;
     delete[] permc;
     delete[] permr;
@@ -231,7 +232,7 @@ SubtractAsI(ARTYPE sigma, NCformat& A, N
   k = 0;
   AsI.colptr[0] = 0;
 
-  for (i=0; i!=n; i++) {
+  for (i=0; i!=this->n; i++) {
 
     j = A.colptr[i];
     end = A.colptr[i+1];
@@ -264,7 +265,7 @@ SubtractAsI(ARTYPE sigma, NCformat& A, N
 
   }
 
-  AsI.nnz = AsI.colptr[n];
+  AsI.nnz = AsI.colptr[this->n];
 
 } // SubtractAsI.
 
@@ -281,13 +282,13 @@ void ARluNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARluNonSymMatrix::FactorA");
   }
 
   // Quitting the function if A is not square.
 
-  if (m != n) {
+  if (this->m != this->n) {
     throw ArpackError(ArpackError::NOT_SQUARE_MATRIX,
                       "ARluNonSymMatrix::FactorA");
   }
@@ -308,7 +309,7 @@ void ARluNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Reserving memory for etree (used in matrix decomposition).
 
-  etree = new int[n];
+  etree = new int[this->n];
 
   // Defining LUStat.
 
@@ -342,7 +343,7 @@ void ARluNonSymMatrix<ARTYPE, ARFLOAT>::
     throw ArpackError(ArpackError::PARAMETER_ERROR,
                       "ARluNonSymMatrix::FactorA");
   }
-  else if (info > n) {    // Memory is not sufficient.
+  else if (info > this->n) {    // Memory is not sufficient.
     throw ArpackError(ArpackError::MEMORY_OVERFLOW,
                       "ARluNonSymMatrix::FactorA");
   }
@@ -360,14 +361,14 @@ void ARluNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED,
                       "ARluNonSymMatrix::FactorAsI");
   }
 
   // Quitting the function if A is not square.
 
-  if (m != n) {
+  if (this->m != this->n) {
     throw ArpackError(ArpackError::NOT_SQUARE_MATRIX,
                       "ARluNonSymMatrix::FactorAsI");
   }
@@ -400,10 +401,10 @@ void ARluNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Creating a temporary matrix AsI.
 
-  irowi = new int[nnz+n];
-  pcoli = new int[n+1];
-  asi   = new ARTYPE[nnz+n];
-  Create_CompCol_Matrix(&AsI, n,  n, nnz, asi, irowi, pcoli, NC, GE);
+  irowi = new int[nnz+this->n];
+  pcoli = new int[this->n+1];
+  asi   = new ARTYPE[nnz+this->n];
+  Create_CompCol_Matrix(&AsI, this->n,  this->n, nnz, asi, irowi, pcoli, NC, GE);
 
   // Subtracting sigma*I from A and storing the result on AsI.
 
@@ -413,7 +414,7 @@ void ARluNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Reserving memory for etree (used in matrix decomposition).
 
-  etree = new int[n];
+  etree = new int[this->n];
 
   // Defining LUStat.
 
@@ -448,7 +449,7 @@ void ARluNonSymMatrix<ARTYPE, ARFLOAT>::
     throw ArpackError(ArpackError::PARAMETER_ERROR,
                       "ARluNonSymMatrix::FactorAsI");
   }
-  else if (info > n) {    // Memory is not sufficient.
+  else if (info > this->n) {    // Memory is not sufficient.
     throw ArpackError(ArpackError::MEMORY_OVERFLOW,
                       "ARluNonSymMatrix::FactorAsI");
   }
@@ -469,15 +470,15 @@ void ARluNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARluNonSymMatrix::MultMv");
   }
 
   // Determining w = M.v.
 
-  for (i=0; i!=m; i++) w[i]=(ARTYPE)0;
+  for (i=0; i!=this->m; i++) w[i]=(ARTYPE)0;
 
-  for (i=0; i!=n; i++) {
+  for (i=0; i!=this->n; i++) {
     t = v[i];
     for (j=pcol[i]; j!=pcol[i+1]; j++) {
       w[irow[j]] += t*a[j];
@@ -496,13 +497,13 @@ void ARluNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARluNonSymMatrix::MultMtv");
   }
 
   // Determining w = M'.v.
 
-  for (i=0; i!=n; i++) {
+  for (i=0; i!=this->n; i++) {
     t = (ARTYPE)0;
     for (j=pcol[i]; j!=pcol[i+1]; j++) {
       t += v[irow[j]]*a[j];
@@ -517,7 +518,7 @@ template<class ARTYPE, class ARFLOAT>
 void ARluNonSymMatrix<ARTYPE, ARFLOAT>::MultMtMv(ARTYPE* v, ARTYPE* w)
 {
 
-  ARTYPE* t = new ARTYPE[m];
+  ARTYPE* t = new ARTYPE[this->m];
 
   MultMv(v,t);
   MultMtv(t,w);
@@ -531,7 +532,7 @@ template<class ARTYPE, class ARFLOAT>
 void ARluNonSymMatrix<ARTYPE, ARFLOAT>::MultMMtv(ARTYPE* v, ARTYPE* w)
 {
 
-  ARTYPE* t = new ARTYPE[n];
+  ARTYPE* t = new ARTYPE[this->n];
 
   MultMtv(v,t);
   MultMv(t,w);
@@ -545,8 +546,8 @@ template<class ARTYPE, class ARFLOAT>
 void ARluNonSymMatrix<ARTYPE, ARFLOAT>::Mult0MMt0v(ARTYPE* v, ARTYPE* w)
 {
 
-  MultMv(&v[m],w);
-  MultMtv(v,&w[m]);
+  MultMv(&v[this->m],w);
+  MultMtv(v,&w[this->m]);
 
 } // Mult0MMt0v.
 
@@ -567,8 +568,8 @@ void ARluNonSymMatrix<ARTYPE, ARFLOAT>::
   int         info;
   SuperMatrix B;
 
-  if (&v != &w) copy(n, v, 1, w, 1);
-  Create_Dense_Matrix(&B, n, 1, w, n, DN, GE);
+  if (&v != &w) copy(this->n, v, 1, w, 1);
+  Create_Dense_Matrix(&B, this->n, 1, w, this->n, DN, GE);
   gstrs("N", &L, &U, permr, permc, &B, &info);
   Destroy_SuperMatrix_Store(&B); // delete B.Store;
 
@@ -581,13 +582,13 @@ DefineMatrix(int np, int nnzp, ARTYPE* a
              double thresholdp, int orderp, bool check)
 {
 
-  m         = np;
-  n         = np;
+  this->m         = np;
+  this->n         = np;
   nnz       = nnzp;
   a         = ap;
   irow      = irowp;
   pcol      = pcolp;
-  pcol[n]   = nnz;
+  pcol[this->n]   = nnz;
   threshold = thresholdp;
   order     = orderp;
 
@@ -600,14 +601,14 @@ DefineMatrix(int np, int nnzp, ARTYPE* a
 
   // Creating SuperMatrix A.
 
-  Create_CompCol_Matrix(&A, n, n, nnz, a, irow, pcol, NC, GE);
+  Create_CompCol_Matrix(&A, this->n, this->n, nnz, a, irow, pcol, NC, GE);
 
   // Reserving memory for vectors used in matrix decomposition.
 
-  permc = new int[n];
-  permr = new int[n];
+  permc = new int[this->n];
+  permr = new int[this->n];
 
-  defined = true;
+  this->defined = true;
 
 } // DefineMatrix (square).
 
@@ -617,14 +618,14 @@ inline void ARluNonSymMatrix<ARTYPE, ARF
 DefineMatrix(int mp, int np, int nnzp, ARTYPE* ap, int* irowp, int* pcolp)
 {
 
-  m       = mp;
-  n       = np;
+  this->m       = mp;
+  this->n       = np;
   nnz     = nnzp;
   a       = ap;
   irow    = irowp;
   pcol    = pcolp;
-  pcol[n] = nnz;
-  defined = true;
+  pcol[this->n] = nnz;
+  this->defined = true;
   permc   = NULL;
   permr   = NULL;
 
diff -rupN arpack++1.2.orig/include/arlnspen.h arpack++1.2.patched/include/arlnspen.h
--- arpack++1.2.orig/include/arlnspen.h	2000-02-22 14:18:59.000000000 +0100
+++ arpack++1.2.patched/include/arlnspen.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARLNSPEN_H
 #define ARLNSPEN_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arerror.h"
 #include "blas1c.h"
diff -rupN arpack++1.2.orig/include/arlscomp.h arpack++1.2.patched/include/arlscomp.h
--- arpack++1.2.orig/include/arlscomp.h	2000-02-21 01:28:44.000000000 +0100
+++ arpack++1.2.patched/include/arlscomp.h	2006-01-26 15:37:50.000000000 +0100
@@ -18,7 +18,8 @@
 #ifndef ARLSCOMP_H
 #define ARLSCOMP_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arscomp.h"
 #include "arlnsmat.h"
@@ -97,7 +98,7 @@ Copy(const ARluCompStdEig<ARFLOAT>& othe
   ARStdEig<ARFLOAT, arcomplex<ARFLOAT>, 
            ARluNonSymMatrix<arcomplex<ARFLOAT>, ARFLOAT> >::
     Copy(other);
-  if (mode > 2) objOP->FactorAsI(sigmaR);
+  if (this->mode > 2) this->objOP->FactorAsI(this->sigmaR);
 
 } // Copy.
 
@@ -106,7 +107,7 @@ template<class ARFLOAT>
 inline void ARluCompStdEig<ARFLOAT>::ChangeShift(arcomplex<ARFLOAT> sigmap)
 {
 
-  objOP->FactorAsI(sigmap);
+  this->objOP->FactorAsI(sigmap);
   ARrcStdEig<ARFLOAT, arcomplex<ARFLOAT> >::ChangeShift(sigmap);
 
 } // ChangeShift.
@@ -118,7 +119,7 @@ inline void ARluCompStdEig<ARFLOAT>::Set
 
   ARStdEig<ARFLOAT, arcomplex<ARFLOAT>, 
            ARluNonSymMatrix<arcomplex<ARFLOAT>, ARFLOAT> >::
-    SetRegularMode(objOP, 
+    SetRegularMode(this->objOP, 
                    &ARluNonSymMatrix<arcomplex<ARFLOAT>, ARFLOAT>::MultMv);
 
 } // SetRegularMode.
@@ -131,7 +132,7 @@ SetShiftInvertMode(arcomplex<ARFLOAT> si
 
   ARStdEig<ARFLOAT, arcomplex<ARFLOAT>, 
            ARluNonSymMatrix<arcomplex<ARFLOAT>, ARFLOAT> >::
-    SetShiftInvertMode(sigmap, objOP,
+    SetShiftInvertMode(sigmap, this->objOP,
                        &ARluNonSymMatrix<arcomplex<ARFLOAT>,ARFLOAT>::MultInvv);
 
 } // SetShiftInvertMode.
@@ -145,7 +146,7 @@ ARluCompStdEig(int nevp, ARluNonSymMatri
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &A,
                    &ARluNonSymMatrix<arcomplex<ARFLOAT>, ARFLOAT>::MultMv,
                    whichp, ncvp, tolp, maxitp, residp, ishiftp);
@@ -176,7 +177,7 @@ operator=(const ARluCompStdEig<ARFLOAT>&
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
